//	SpecialChars Class
//	============================================================================
//	VERSION HISTORY:
//
//	Date		Vers	Author			Change
//	----------------------------------------------------------------------------	
//	02.10.04	1.0		Kishore			First build
//	

// USAGE:
// specify the following special chars in the external data file (like xml)
// &cp;   ---  for copyright symbol
// &rg;   ---  for registered symbol
// &tm;   ---  for trademark symbol
// &sm;   ---  for service symbol
// &ss1;  ---  for superscript symbol 1
// &ss2;  ---  for superscript symbol 2
// &ss3;  ---  for superscript symbol 3
// &sp;   ---  for blank space
// &sp2;  ---  for 2 blank spaces
// &sp3;  ---  for 3 blank spaces
// &sp4;  ---  for 4 blank spaces
// &sp5;  ---  for 5 blank spaces
// &sp6;  ---  for 6 blank spaces
// &sp7;  ---  for 7 blank spaces
// &sp8;  ---  for 8 blank spaces
// &sp9;  ---  for 9 blank spaces
// &sub1; --- for Subscript symbol 1
// &sub2; --- for Subscript symbol 2
// &sub3; --- for Subscript symbol 3

// METHOD:
// decode(pass_formated_string_with_special_chars)

// RETURN:
// It ruturns the decode string.

// EXAMPLE:
// strOut = SpecialChars.decode(FormatedString_with_SpecialChars);

// NOTE:
// SpecialChars is a global object. So that u can call this in any timeline as shown in the above example.

_global.SpecialChars = new Object();
SpecialChars.cp = "\u00A9";
SpecialChars.rg = "\u00AE";
SpecialChars.tm = "\u2122";
SpecialChars.sm = "\u2120";
SpecialChars.tk = "\u221A";
SpecialChars.ar = "\25BA";
SpecialChars.sp = "\u0020";
SpecialChars.ss1 = "\u00B9";
SpecialChars.ss2 = "\u00B2";
SpecialChars.ss3 = "\u00B3";

SpecialChars.sub1 = "\u2081";
SpecialChars.sub2 = "\u2082";
SpecialChars.sub3 = "\u2083";

SpecialChars.sp2 = 2;
SpecialChars.sp3 = 3;
SpecialChars.sp4 = 4;
SpecialChars.sp5 = 5;
SpecialChars.sp6 = 6;
SpecialChars.sp7 = 7;
SpecialChars.sp8 = 8;
SpecialChars.sp9 = 9;
SpecialChars.decode = function(strIn){

	if(strIn != undefined && strIn.length > 1){
		var tags = new Array("ol");
		for(var t=0; t<tags.length; ++t){
			var tindexes = new Array();
			var tstart = "<"+tags[t]+">";
			var tend = "</"+tags[t]+">";
			var arrList;
			var strList = "";
			var index1 = strIn.indexOf(tstart);
			var index2 = -1;
			if(index1 >= 0){
				while( index1 >= 0){
					tindexes.push(index1);
					index1 = strIn.indexOf(tstart, index1+tstart.length);
				}
				while(tindexes.length > 0){
					index1 = tindexes[tindexes.length-1];
					index2 = strIn.indexOf(tend, index1+4);
					if(index2 >= 0){
						arrList = strIn.slice(index1+4, index2).replace("</li>", "<br>").split("<li>");
						strList = "";
						for(var i=1; i<arrList.length; ++i){
							if(tags[t] == "ol")
								strList += i+ ".&sp2;" +arrList[i];
						}
						if(strList != ""){
							strList = "<TEXTFORMAT BLOCKINDENT=\"18\">" + strList + "</TEXTFORMAT>";
							strIn = strIn.slice(0, index1) + strList + strIn.slice(index2+tend.length);
						}
					}
					tindexes.pop();
				}
			}
		}

		var strJoinWith;
		for(var key in this){
			if(typeof(key) == "string" && strIn.indexOf("&"+key+";") >= 0){
				strJoinWith = "";
				if(key.indexOf("sp") >= 0 && key.length > 2){
					for(var i=1; i<=Number(this[key]); ++i){
						strJoinWith += this["sp"];
					}
				}else{
					strJoinWith = this[key];
				}
				strIn = strIn.replace("&"+key+";", strJoinWith);
			}
		}

		for(var i=1; i<=10; ++i){
			if(strIn.indexOf("<tab"+i+">") >= 0){
				strIn = strIn.replace("<tab"+i+">", "<TEXTFORMAT BLOCKINDENT=\""+ (18*i) + "\">");
				strIn = strIn.replace("</tab"+i+">", "</TEXTFORMAT>");
			}
		}
	}
	return strIn;
}



// Purpoose:
// This is a string replace function
//
// Return:
// The return type of this function is string value.
String.prototype.replace = function(strSearch, strReplace){
	return this.split(strSearch).join(strReplace);
}